function [fi,lamda,alfa] = RK4a(fi0,lamda0,alfa0,aX)
%[fi,lamda,alfa] = RK4f(fi0,lamda0,alfa0,aX)
%bod s danym azimutem
%
%fi0,lamda0,alfa0 = vychozi bod na geodeticke krivce
%aX = azimut pro kterou chces urcit fi a lamda


if((alfa0 > 180) & (aX < 180))
    fprintf('\nGeodeticka krivka ma SZ smer =>\nazimut %.f %.f'' %.f'''' bude opraven o 180 na %.f %.f'' %.f''''\n\n',dms2mat(deg2dms(aX)),dms2mat(deg2dms(aX+180)));
    aX = aX + 180;
end

if((alfa0 < 180) & (aX > 180))
    fprintf('\nGeodeticka krivka ma SV smer =>\nazimut %.f %.f'' %.f'''' bude opraven o 180 na %.f %.f'' %.f''''\n\n',dms2mat(deg2dms(aX)),dms2mat(deg2dms(aX-180)));
    aX = aX - 180;
end


%pocatecni hodnoty
fn = fi0;
ln = lamda0;
an = alfa0;

%pocatecni iteracni krok v [km]
h = 100e3;
if(an > aX)
    h = -h;
end


pol = sign(an - aX);

%vzdalenost = 0;


%----------------------------------------------------------------
%fprintf(1,'\n\ncas 1: %.3f vterin\n\n',toc);

for i=1:5

% fprintf(1,'\n sirka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(fn)));
% fprintf(1,' delka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(ln)));
% fprintf(1,'azimut = %4.f %.f'' %.2f''''\n\n',dms2mat(deg2dms(an)));

while (pol == sign(an-aX));

% R-K4 jdro
kf1 = f1(fn,an);
kl1 = f2(fn,an);
ka1 = f3(fn,an);

kf2 = f1(fn + (h/2)*kf1,an + (h/2)*ka1);
kl2 = f2(fn + (h/2)*kf1,an + (h/2)*ka1);
ka2 = f3(fn + (h/2)*kf1,an + (h/2)*ka1);

kf3 = f1(fn + (h/2)*kf2,an + (h/2)*ka2);
kl3 = f2(fn + (h/2)*kf2,an + (h/2)*ka2);
ka3 = f3(fn + (h/2)*kf2,an + (h/2)*ka2);

kf4 = f1(fn + h*kf3,an + h*ka3);
kl4 = f2(fn + h*kf3,an + h*ka3);
ka4 = f3(fn + h*kf3,an + h*ka3);


fnpp = fn + (h/6)*(kf1 + 2*kf2 + 2*kf3 + kf4);
lnpp = ln + (h/6)*(kl1 + 2*kl2 + 2*kl3 + kl4);
anpp = an + (h/6)*(ka1 + 2*ka2 + 2*ka3 + ka4);

fn = fnpp;
ln = lnpp;
an = anpp;
% R-K4 jdro END

%vzdalenost = vzdalenost - h*pol;

end%while

h = -h/1000;
pol = -pol;


end%for



% fprintf(1,'X  sirka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(fn)));
% fprintf(1,'X  delka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(ln)));
% fprintf(1,'X azimut = %4.f %.f'' %.2f''''\n\n\n',dms2mat(deg2dms(an)));
%----------------------------------------------------------------

%navratove hodnoty
fi = fn;
lamda = ln;
alfa = an;


if(alfa >= 360)
    alfa = alfa - 360;
end


if(lamda > 180)
    lamda = lamda - 360;
end

if(lamda < -180)
    lamda = lamda + 360;
end

%fprintf(1,'%.12f\n',vzdalenost);