function [fn,ln] = ort_k_prusecik(f1,l1,a1,f2,l2,a2);
%prusecik ortodrom
ro = 180/pi;
R = 6378000;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fn = 23.5;
[ln,q] = ort_k_f2la(f1,l1,a1,fn);

UA = fn;
VA = ln;
%---

fn = 0;
[ln,q] = ort_k_f2la(f1,l1,a1,fn);

UD = fn;
VD = ln;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ln = -30;
[fn,q] = ort_k_l2fa(f2,l2,a2,ln);


UB = fn;
VB = ln;
%---

fn = 23.5;
[ln,q] = ort_k_f2la(f2,l2,a2,fn);


UC = fn;
VC = ln;

%---------------------
UA = UA/ro;
VA = VA/ro;

UB = UB/ro;
VB = VB/ro;

UC = UC/ro;
VC = VC/ro;

UD = UD/ro;
VD = VD/ro;


%%%%%%%%%%%%%%%%%%%%%%%%%%
xA = R * cos(UA) * cos(VA);
yA = R * cos(UA) * sin(VA);
zA = R * sin(UA);

xB = R * cos(UB) * cos(VB);
yB = R * cos(UB) * sin(VB);
zB = R * sin(UB);

xC = R * cos(UC) * cos(VC);
yC = R * cos(UC) * sin(VC);
zC = R * sin(UC);

xD = R * cos(UD) * cos(VD);
yD = R * cos(UD) * sin(VD);
zD = R * sin(UD);

%%%%%%%%%%%%%%%%%%%%%%%
A = [
    xA xD xB
    yA yD yB
    zA zD zB    
];

a = [
    xC
    yC
    zC
];

%%%%%%%%%%%%%%%%%%%

x = inv(A)*a;

%%%%%%%%%%%%%%%%%%%
u1 = xA*x(1)+xD*x(2);
u2 = yA*x(1)+yD*x(2);
u3 = zA*x(1)+zD*x(2);

u = (u1^2 + u2^2 + u3^2)^0.5;


v1 = xB*x(3)+xC;
v2 = yB*x(3)+yC;
v3 = zB*x(3)+zC;

n1 = u1/u*R;
n2 = u2/u*R;
n3 = u3/u*R;

fn = ro * asin(n3/R);
ln = ro * acos(n1/R/cos(fn/ro));

%nevm proc, ale obcas zlob znamnko vsledku...
[lX,aX] = ort_k_f2la(f1,l1,a1,fn);

if((lX/abs(lX)) ~= (ln/abs(ln)))
    ln = -ln;
end