%VG11 uloha 2.3 (geodeticka krivka)
%RSC (rsc@email.cz)

clear %vymazani pameti
clc %smazani obrazovky

tic;%spousti stopky

fid = fopen('2.3.txt','w'); %vytvoreni *.txt souboru pro vystup

%parametry Besselova elipsoidu
a = 6377397.15508;
e2 = 0.006674372230622;

ro = 180/pi;

fprintf('\n\nITERACNI ZPUSOB RESENI JE CASOVE NAROCNY,\nTAKZE CELY VYPOCET MUZE TRVAT I 20 VTERIN\n\n');

fprintf(fid,'VG11 - uloha 2.3\n');
fprintf(fid,'----------------\n\n');

%vstupni hodnoty  <|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
fA = [-85 52 21.000];
lA = [60 16 34.000];
aA = [221 24 35.000];
fA = dms2deg(mat2dms(fA));
lA = dms2deg(mat2dms(lA));
aA = dms2deg(mat2dms(aA));
%<|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

fprintf(fid,'Geodetick krivka na Besselove elipsoidu dana bodem\n\n');



fprintf(fid,'Bod A\n');
fprintf(fid,'----------------------------\n');
fprintf(fid,' sirka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(fA)));
fprintf(fid,' delka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(lA)));
fprintf(fid,'azimut = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(aA)));

pom1 = N(a,e2,fA)*cos(fA/ro)*sin(aA/ro);

%fprintf('\n\t\tcas od zacatku vypoctu: %.3f vterin\n',toc);

%-----------------------------------------------------------------

fprintf(fid,'\n\nPrusecik s rovnikem\n');
fprintf(fid,'----------------------------\n');

[fn,ln,an] = RK4f(fA,lA,aA,0);

fprintf(fid,' sirka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(fn)));
fprintf(fid,' delka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(ln)));
fprintf(fid,'azimut = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(an)));

pom2 = N(a,e2,fn)*cos(fn/ro)*sin(an/ro);

fprintf('\n\t\tcas od zacatku vypoctu: %.3f vterin (Prusecik s rovnikem)\n',toc);

%-----------------------------------------------------------------

fprintf(fid,'\n\nPrusecik s nultym polednikem\n');
fprintf(fid,'----------------------------\n');

[fn,ln,an] = RK4l(fA,lA,aA,0);

fprintf(fid,' sirka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(fn)));
fprintf(fid,' delka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(ln)));
fprintf(fid,'azimut = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(an)));

pom3 = N(a,e2,fn)*cos(fn/ro)*sin(an/ro);

fprintf('\n\t\tcas od zacatku vypoctu: %.3f vterin (Prusecik s nultym polednikem)\n',toc);

%-----------------------------------------------------------------

fprintf(fid,'\n\nNejsevernejsi bod\n');
fprintf(fid,'----------------------------\n');

[fn,ln,an] = RK4nejsever(fA,lA,aA);

fprintf(fid,' sirka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(fn)));
fprintf(fid,' delka = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(ln)));
fprintf(fid,'azimut = %4.f %.f'' %.2f''''\n',dms2mat(deg2dms(an)));

pom4 = N(a,e2,fn)*cos(fn/ro)*sin((an)/ro);

fprintf('\n\t\tcas od zacatku vypoctu: %.3f vterin (Nejsevernejsi bod)\n',toc);

%-----------------------------------------------------------------

 fprintf(fid,'\n\nKontrola presnosti vypoctu (melo by se shodovat na min. 10 platnych cifer)\npodle vzorce N*cos(fi)*sin(alfa) = konst\n');

 fprintf(fid,'K1: %+10.12f\n',pom1);
 fprintf(fid,'K2: %+10.12f\n',pom2);
 fprintf(fid,'K3: %+10.12f\n',pom3);
 fprintf(fid,'K4: %+10.12f\n',pom4);

%-----------------------------------------------------------------

fclose(fid);
fprintf('\n\nCiselne vysledky jsou ulozeny v souboru "2.3.txt"\n v pracovnim adresari\n\n');
