%VG11 uloha 2.4 (polomery krivosti)
%RSC (rsc@email.cz)

clear %vymazani pameti
clc %smazani obrazovky


fid = fopen('2.4.txt','w'); %vytvoreni *.txt souboru pro vystup

%parametry Besselova elipsoidu
a = 6377397.15508;
e2 = 0.006674372230622;

ro = 180/pi;

%CAST 2.4a %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf(fid,'VG11 - uloha 2.4\n');
fprintf(fid,'----------------\n\n');


fprintf(fid,'Meridianovy, pricny a stredni polomer krivosti pro Besseluv elipsoid pro fi = <0;90)\n\n');

fprintf(fid,'    fi []    M [km]         N [km]         R [km]\n');
fprintf(fid,'    ------------------------------------------------\n');

for i=0:5:90
    fprintf(fid,'\t %2.f \t %.3f \t %.3f \t %.3f\n',i,M(a,e2,i),N(a,e2,i),R(a,e2,i));
    
    if(i == 0)
        fi(1) = i;
        yM(1) = M(a,e2,i);
        yN(1) = N(a,e2,i);
        yR(1) = R(a,e2,i);        
    end

    if(i ~= 0)
        fi(end+1) = i;
        yM(end+1) = M(a,e2,i);
        yN(end+1) = N(a,e2,i);
        yR(end+1) = R(a,e2,i);        
    end
        
end

figure(1);
hold on;
title('MNR','FontWeight','bold','FontSize',12,'FontAngle','italic','VerticalAlignment','bottom');
plot(fi,yM);
plot(fi,yN,'r');
plot(fi,yR,'k');
xlabel('fi []');
ylabel('polomer [km]');

















%CAST 2.4b %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf(fid,'\n\nPrubeh polomeru krivosti normalovaho rezu R alfa v azimutu alfa = <0;180>\n\n');
fprintf(fid,'Bod P:\n');

%vstupni hodnoty  <|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
fA = [-85 52 21.000];
lA = [60 16 34.000];
aA = [221 24 35.000];
fP = dms2deg(mat2dms(fA));
lP = dms2deg(mat2dms(lA));
aP = dms2deg(mat2dms(aA));
%<|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||


MP = M(a,e2,fP);
NP = N(a,e2,fP);
RP = R(a,e2,fP);

fprintf(fid,' sirka = %4.f %2.f'' %2.2f''''\n',dms2mat(deg2dms(fP)));
fprintf(fid,' delka = %4.f %2.f'' %2.2f''''\n',dms2mat(deg2dms(lP)));
fprintf(fid,'     M = %13.3f m\n',MP);
fprintf(fid,'     N = %13.3f m\n',NP);
fprintf(fid,'     R = %13.3f m\n\n\n',RP);


fprintf(fid,'    alfa []    R alfa [km]\n');
fprintf(fid,'    -----------------------\n');
for i=0:5:180

    pom = 1/(((cos(i/ro)^2)/MP) + ((sin(i/ro)^2)/NP));
    
    if(i == 0)
        alfa(1) = i;
        Ralfa(1) = pom;
    end

    if(i ~= 0)
        alfa(end+1) = i;
        Ralfa(end+1) = pom;
    end

        fprintf(fid,'\t %3.f \t %.3f \n',i,pom);
        
end

figure(2);
hold on;
title('R alfa','FontWeight','bold','FontSize',12,'FontAngle','italic','VerticalAlignment','bottom');
plot(alfa,Ralfa);
xlabel('alfa []');
ylabel('polomer [km]');


fclose(fid);
fprintf('Ciselne vysledky jsou ulozeny v souboru "2.4.txt"\n v pracovnim adresari\n\n');